package br.com.techsage.handler;

import java.util.ArrayList;
import java.util.List;

import javax.faces.component.html.HtmlSelectOneMenu;
import javax.faces.context.FacesContext;
import javax.faces.event.ActionEvent;
import javax.faces.event.ValueChangeEvent;
import javax.faces.model.SelectItem;
import javax.servlet.http.HttpSession;

import org.hibernate.Query;
import org.hibernate.Session;

import br.com.techsage.dao.Dao;
import br.com.techsage.tabela.AcessoCentroCusto;
import br.com.techsage.tabela.AcessoEmpresa;
import br.com.techsage.tabela.CentroCusto;
import br.com.techsage.tabela.Usuario;
import br.com.techsage.util.HibernateUtil;

public class AcessoCentroCustoHandler {
	private AcessoCentroCusto acessoCentroCusto = new AcessoCentroCusto();
	private Dao<AcessoCentroCusto> dao;
	private Dao<CentroCusto> daoCentroCusto;
	private Dao<Usuario> daoUsuario;
	private List<AcessoCentroCusto> listaAcessoCentroCusto;
	private List<Long> listaAcessoCentroCustoDestino = new ArrayList<Long>();
	private String nomeUsuario;
	private String idNewUser;
	private HtmlSelectOneMenu empresaSelecionado;
	
	public AcessoCentroCusto getAcessoCentroCusto() {
		return acessoCentroCusto;
	}

	public void setAcessoCentroCusto(AcessoCentroCusto acessoCentroCusto) {
		this.acessoCentroCusto = acessoCentroCusto;
	}

	public List<AcessoCentroCusto> getListaAcessoCentroCusto() {
		return listaAcessoCentroCusto;
	}

	public void setListaAcessoCentroCusto(
			List<AcessoCentroCusto> listaAcessoCentroCusto) {
		this.listaAcessoCentroCusto = listaAcessoCentroCusto;
	}

	public List<Long> getListaAcessoCentroCustoDestino() {
		return listaAcessoCentroCustoDestino;
	}

	public void setListaAcessoCentroCustoDestino(
			List<Long> listaAcessoCentroCustoDestino) {
		this.listaAcessoCentroCustoDestino = listaAcessoCentroCustoDestino;
	}

	public String getNomeUsuario() {
		return nomeUsuario;
	}

	public void setNomeUsuario(String nomeUsuario) {
		this.nomeUsuario = nomeUsuario;
	}

	public String getIdNewUser() {
		return idNewUser;
	}

	public void setIdNewUser(String idNewUser) {
		this.idNewUser = idNewUser;
	}

	public HtmlSelectOneMenu getEmpresaSelecionado() {
		return empresaSelecionado;
	}

	public void setEmpresaSelecionado(HtmlSelectOneMenu empresaSelecionado) {
		this.empresaSelecionado = empresaSelecionado;
	}

	public void setSessao(Session session) {
		this.dao = new Dao<AcessoCentroCusto>(session, AcessoCentroCusto.class);
		this.daoCentroCusto = new Dao<CentroCusto>(session, CentroCusto.class);
		this.daoUsuario = new Dao<Usuario>(session, Usuario.class);
		HttpSession ses = (HttpSession) FacesContext.getCurrentInstance().getExternalContext().getSession(false);
		if (ses.getAttribute("idNewUser") != null)
		{
			String id = ses.getAttribute("idNewUser").toString();
			this.setIdNewUser(id);
			this.setNomeUsuario(this.daoUsuario.load(Long.parseLong(id)).getNomeAcesso());
			// this.setListaAcessoCentroCustoDestino(this.listaAcessoCentroCusto(id));
		}	
		else
		{
			this.setIdNewUser("0");
			this.listaAcessoCentroCustoDestino.add(0L);
		}
		org.hibernate.Filter filter = session.getEnabledFilter("AcessoCentrosCusto");
		if (filter != null) {
			session.disableFilter("AcessoCentrosCusto");
		}		
	}	
	
	public String salvar() throws Exception
	{
		this.dao.merge(this.acessoCentroCusto);
		this.acessoCentroCusto = new AcessoCentroCusto();
		this.setListaAcessoCentroCusto(null);
		return "sucesso";
	}
	
	public String deletar() throws Exception
	{
		Long idNewUser = 0L;
		Long centroCusto = 0L;
    	if (this.getIdNewUser() != null) {
    		idNewUser = Long.parseLong(this.getIdNewUser());
    		this.acessoCentroCusto.setUsuario(daoUsuario.load(idNewUser));
    		this.acessoCentroCusto.setCentroCusto(daoCentroCusto.load(centroCusto));
    		this.dao.delete(this.acessoCentroCusto);
    	}
		this.acessoCentroCusto = new AcessoCentroCusto();
		this.setListaAcessoCentroCusto(null);
		return "stayhere";
	}
	
	public String cancelar()
	{
		this.acessoCentroCusto = new AcessoCentroCusto();
		this.setListaAcessoCentroCusto(null);		
		return "stayhere";
	}
	
	public List<AcessoCentroCusto> getAcessoCentroCustos() {
		List<AcessoCentroCusto> list = this.getListaAcessoCentroCusto();
		if (list == null || list.size() == 0)
		{
			String[] args = new String[1];
			String[] sort = new String[2];
			sort[0] = "usuario";
			sort[1] = "centroCusto";
			list = this.dao.search(args, sort);
		}
		return list;		
	}	
	
	public String buscar()
	{
		String centroCusto = this.acessoCentroCusto.getCentroCusto().getId().toString();
		String usuario = this.acessoCentroCusto.getUsuario().getId().toString();
		String[] args = new String[2];
		String[] sort = new String[2];
		if (centroCusto != null && centroCusto != "") {
			args[0] = "centroCusto.id;" + centroCusto + ";eqL";
		}
		if (usuario != null && usuario != "") {
			args[1] = "usuario.id;" + usuario + ";eqL";
		}
		sort[0] = "usuario";
		sort[1] = "centroCusto";
		List<AcessoCentroCusto> lista = this.dao.search(args, sort);
		this.setListaAcessoCentroCusto(lista);
		return "stayhere";		
	}
	
	public void escolheAcessoCentroCusto(ActionEvent event) {
		/*
		UIComponent link = event.getComponent();
		UIParameter param = (UIParameter) link.findComponent("editId");
		String id = (String) param.getValue();
		*/
		FacesContext context = FacesContext.getCurrentInstance();
		String id = context.getExternalContext().getRequestParameterMap().get("editId").toString();
    	if (this.getIdNewUser() != null) {
    		Long idNewUser = Long.parseLong(this.getIdNewUser());
    		this.acessoCentroCusto.setUsuario(this.daoUsuario.load(idNewUser));
    		this.acessoCentroCusto.setCentroCusto(this.daoCentroCusto.load(Long.parseLong(id)));
    	}
	}	
	
    @SuppressWarnings("unchecked")
	public List<SelectItem> getCentroCustoPickList() {
        List<SelectItem> lista = new ArrayList<SelectItem>();
		Long empresa = (this.empresaSelecionado != null && this.empresaSelecionado.getValue() != null ? Long.parseLong(this.empresaSelecionado.getValue().toString()) : 0L);
		if (empresa != 0L) {
    		Session session = HibernateUtil.getCurrentSession();
    		session.beginTransaction();
    	    	String hql = "from CentroCusto where empresa.id = :empresa order by centroCusto";
    	    	Query query = session.createQuery(hql);
    	    	query.setLong("empresa", empresa);
    	    	query.setCacheable(false);
    	    	List<CentroCusto> list = query.list();
    	    	if (list.size() > 0) {
    	    		for (CentroCusto cc : list) {
    	    			lista.add(new SelectItem(cc.getId(), cc.getCentroCusto() + " - " + cc.getDescricao()));
    	    		}
    	    	}
    	    session.getTransaction().commit();
    		this.setListaAcessoCentroCustoDestino(this.listaAcessoCentroCusto(this.getIdNewUser()));
		}
        return lista;
    }
  
    public String salvarAcessoCentroCusto()
    {
    	if (this.getIdNewUser() != null) {
    		Long idNewUser = Long.parseLong(this.getIdNewUser());
    		Long empresa = (this.empresaSelecionado != null && this.empresaSelecionado.getValue() != null ? Long.parseLong(this.empresaSelecionado.getValue().toString()) : 0L);
    		Object[] ctos = this.listaAcessoCentroCustoDestino.toArray();
    		
    	    /*
    	     * Deleo dos centros de custo
    	     */
    		Session session = HibernateUtil.getCurrentSession();
    		session.beginTransaction();
    			String hql;
    			Query query;
    			if (ctos.length > 0) {
    				hql = "delete from AcessoCentroCusto where usuario.id = :user and str(centroCusto.id) not in (:ctos) and centroCusto.id in (select id from CentroCusto where str(empresa.id) = (:empresa))";
    			}
    			else {
    				hql = "delete from AcessoCentroCusto where usuario.id = :user and centroCusto.id in (select id from CentroCusto where str(empresa.id) = (:empresa))";	    				
    			}	    				
    	    	query = session.createQuery(hql);
    	    	query.setLong("user", idNewUser);
    	    	query.setLong("empresa", empresa);
    	    	if (ctos.length > 0) {
    	    		query.setParameterList("ctos", this.listaAcessoCentroCustoDestino);
    	    	}
    	    	int rowCount = query.executeUpdate();
    	    	System.out.println("Ctos Custo Apagados: " + rowCount);
    	    	//
    	    	for (int i = 0; i < ctos.length; i++) {
    	    		this.acessoCentroCusto = new AcessoCentroCusto();
    	    		this.acessoCentroCusto.setUsuario(daoUsuario.load(idNewUser));
    	    		this.acessoCentroCusto.setCentroCusto(daoCentroCusto.load(Long.parseLong(ctos[i].toString())));
    	    		try {
        	    		session.saveOrUpdate(this.acessoCentroCusto);
    	    			// this.salvar();
    	    		} catch (Exception e) {
    	    			// TODO Auto-generated catch block
    	    			e.printStackTrace();
    	    			return "erro";
    	    		}
    	    	}
    	    session.getTransaction().commit();
    	    this.setListaAcessoCentroCustoDestino(this.listaAcessoCentroCusto(String.valueOf(idNewUser)));
    	    @SuppressWarnings("unused")
			List<SelectItem> lista = this.getCentroCustoPickList();
    	}
        return "sucesso";
    }
    
    @SuppressWarnings("unchecked")
	private List<Long> listaAcessoCentroCusto(String user) {
    	List<Long> lista = new ArrayList<Long>();
		Long empresa = (this.empresaSelecionado != null && this.empresaSelecionado.getValue() != null ? Long.parseLong(this.empresaSelecionado.getValue().toString()) : 0L);
		if (empresa != 0L) {
			Session session = HibernateUtil.getCurrentSession();
			session.beginTransaction();
	    		/* String hql = "from AcessoCentroCusto where usuario.id = :user and centroCusto.id in (select id from CentroCusto where empresa.id = :empresa) order by centroCusto.centroCusto"; */
				String hql = "from AcessoCentroCusto ac where ac.usuario.id = :user and ac.centroCusto.empresa.id = :empresa order by ac.centroCusto.centroCusto";
	    		Query query = session.createQuery(hql);
	    		query.setLong("user", Long.parseLong(user));
	    		query.setLong("empresa", empresa);
	    		query.setCacheable(false);
	    		List<AcessoCentroCusto> centroCustoUser = query.list();
	    		if (centroCustoUser.size() > 0) {
	    			for (AcessoCentroCusto cc : centroCustoUser) {
	    				lista.add(cc.getCentroCusto().getId());
	    			}
	    		}
	    	session.getTransaction().commit();
		}
		return(lista);
    }
    
	public void populateSector(ValueChangeEvent event) {
		@SuppressWarnings("unused")
		List<SelectItem> lista = this.getCentroCustoPickList();
	}	    
    
	@SuppressWarnings("unchecked")
	public List<SelectItem> getEmpresaComboBox() {
		List<SelectItem> lista = new ArrayList<SelectItem>();
		String user = this.getIdNewUser();
		lista.add(new SelectItem("0", "---- Selecione uma empresa ----"));
    	Session session = HibernateUtil.getCurrentSession();
    	session.beginTransaction();
	    	String hql = "from AcessoEmpresa where usuario.id = :user order by empresa.razaoSocial";
	    	Query query = session.createQuery(hql);
	    	query.setLong("user", Long.parseLong(user));
	    	List<AcessoEmpresa> empresaUser = query.list();
		session.getTransaction().commit();
		
		for (AcessoEmpresa ae : empresaUser) {
			lista.add(new SelectItem(ae.getEmpresa().getId(), ae.getEmpresa().getRazaoSocial()));
		}
		return lista;
	}    
    
    public String voltar() {
    	return "voltar";
    }
	
    public String proximo() {
    	return "proximo";
    }
}
